#include<bits/stdc++.h>

using namespace std;

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

const int kMaxN = 2e5 + 10;
int tree[kMaxN * 4];

void update(int i, int l, int r, int req, int delta) {
    if (l + 1 == r) {
        tree[i] += delta;
        return;
    }
    int m = (l + r) / 2;
    if (req < m) {
        update(2 * i + 1, l, m, req, delta);
    } else {
        update(2 * i + 2, m, r, req, delta);
    }
    tree[i] = std::max(tree[2 * i + 1], tree[2 * i + 2]);
}

int getValue(int i, int l, int r, int req) {
    if (l + 1 == r) {
        return tree[i];
    }
    int m = (l + r) / 2;
    if (req < m) {
        return getValue(2 * i + 1, l, m, req);
    }
    return getValue(2 * i + 2, m, r, req);
}

int getMaxIndex(int i, int l, int r) {
    if (l + 1 == r) {
        return l;
    }
    int m = (l + r) / 2;
    if (tree[2 * i + 1] > tree[2 * i + 2]) {
        return getMaxIndex(2 * i + 1, l, m);
    }
    return getMaxIndex(2 * i + 2, m, r);
}

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::map<int, std::set<int> > edges;
    std::map<int, std::set<int> > rev_edges;
    for (int i = 0; i < m; ++i) {
        int v, u;
        std::cin >> v >> u;
        --v;
        --u;
        edges[v].insert(u);
        rev_edges[u].insert(v);
    }
    for (int i = 0; i < n; ++i) {
        update(0, 0, n, i, edges[i].size());
    }
    std::vector<int> answer(n);
    std::vector<int> used(n, false);
    int i;
    for (i = 0; i < n; ++i) {
        /*
        for (int j = 0; j < n; ++j) {
            std::cout << getValue(0, 0, n, j) << " ";
        }
        std::cout << "\n";
        */
        int index = getMaxIndex(0, 0, n);
        if (getValue(0, 0, n, index) == 0) {
            break;
        }
        answer[i] = index;
        used[index] = true;
        for (auto el : edges[index]) {
            rev_edges[el].erase(index);
        }
        update(0, 0, n, index, (int)edges[index].size() * (-1));
        edges[index].clear();
        for (auto el : rev_edges[index]) {
            edges[el].erase(index);
            update(0, 0, n, el, -1);
        }
        rev_edges[index].clear();
    }
    for (int index = 0; index < n; ++index) {
        if (!used[index]) {
            answer[i++] = index;
        }
    }
    for (auto el : answer) {
        std::cout << el + 1 << " ";
    }
    std::cout << "\n";
    return;
}

int32_t main() {
    IOSync();
    int tests = 1;
    std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
