﻿#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using ll = long long;
using db = double;
const int inf = 10000000009;
using namespace std;


const int maxn = 10e6;
vector<bool> visited;
vector<pair<int, int>> ans;

int tout = 1;

void dfs(int v, vector<vector<int>>& g) {
    for (auto u : g[v]) {
        if (!visited[u]) {
            visited[u] = true;
            dfs(u, g);
            
            ans.push_back({tout, u});
        }
    }
    tout += 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n, vector<int>());
    visited.assign(n, 0);
    ans.clear();
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
    }
    for (int v = 0; v < n; v++) {
        if (!visited[v]) {
            dfs(v, g);
        }
    }
    sort(ans.begin(), ans.end(), greater<pair<int, int>>());
    for (auto u : ans) {
        cout << u.second+1 << " ";
    }
    cout << endl;
}


int main(){

#ifdef DEBUG
    auto f = freopen("test.txt", "r", stdin);
    cout << "Debug Mode" << endl;
#endif // DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    
}


