﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <cmath>
#include <cstdlib>
#include <numeric>
#include <chrono>
#include <climits>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<ll>> g;
vector<char> used;
vector<ll> ans;
ll num;

void dfs(ll u) {
    used[u] = true;

    for (ll i = 0; i < g[u].size(); i++)
    {
        ll v = g[u][i];
        if (!used[v])
            dfs(v);
    }

    ans[u] = num--;
}

void solve() {
    ll n, m;
    cin >> n >> m;

    g.clear();
    used.clear();
    ans.clear();
    g.resize(n);
    for (ll i = 0; i < g.size(); i++)
    {
        g[i].clear();
    }
    used.resize(n);
    ans.resize(n);
    num = n;

    ll u, v;
    for (ll i = 0; i < m; i++)
    {
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
    }

    for (ll i = 0; i < n; ++i) {
        if (used[i])
            continue;

        dfs(i);
    }

    ll correntCnt = 0;
    for (ll i = 0; i < n; i++)
    {
        for (ll j = 0; j < g[i].size(); j++)
        {
            if (ans[i] < ans[g[i][j]]) {
                correntCnt++;
            }
        }
    }

    ll check = m / 2;
    if (m % 2 == 1) {
        check++;
    }
    if (check <= correntCnt) {
        for (ll i = 0; i < n; i++)
        {
            cout << ans[i] << " ";
        }
    }
    else {
        cout << -1;
    }
    cout << endl;
}

void multitest() {
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

void preCalc() {

}

void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    fastIO();
#ifdef _DEBUG
    auto start = chrono::system_clock().now();
#endif
    preCalc();
    multitest();
#ifdef _DEBUG
    auto end = chrono::system_clock().now();
    cout << "\n" << (end - start).count() / 1e7 << " seconds\n";
#endif
}
