from collections import defaultdict


class Obj:
    def __init__(self, val, arr_idx):
        self.val = val
        self.heap_idx = -1
        self.arr_idx = arr_idx

    def __str__(self):
        return str(self.val) + " " + str(self.arr_idx) + " " + str(self.heap_idx)
    def __repr__(self):
        return self.__str__()


def heappush(heap, obj: Obj):
    heap.append(obj)  # move
    heap[-1].heap_idx = len(heap) - 1

    _siftdown(heap, 0, len(heap)-1)


def heappop(heap):
    lastelt = heap.pop()
    if heap:
        returnitem = heap[0]
        heap[0] = lastelt  # move
        heap[0].heap_idx = 0
        _siftup(heap, 0)
        return returnitem
    return lastelt


def heappop_i(heap, i):
    popped = heap[i]
    heap[i] = heap[-1] # move
    heap[i].heap_idx = i
    heap.pop()

    _siftdown(heap, i, len(heap) - 1)
    if i < len(heap):
        _siftup(heap, i)

    return popped


def _siftup(heap, pos):
    endpos = len(heap)
    startpos = pos
    newitem = heap[pos]

    childpos = 2*pos + 1
    while childpos < endpos:
        rightpos = childpos + 1
        if rightpos < endpos and not heap[childpos].val > heap[rightpos].val:
            childpos = rightpos

        heap[pos] = heap[childpos]  # move
        heap[pos].heap_idx = pos

        pos = childpos
        childpos = 2*pos + 1

    heap[pos] = newitem  # move
    heap[pos].heap_idx = pos

    _siftdown(heap, startpos, pos)


def _siftdown(heap, startpos, pos):
    newitem = heap[pos]

    while pos > startpos:
        parentpos = (pos - 1) >> 1
        parent = heap[parentpos]
        if newitem.val > parent.val:
            heap[pos] = parent  # move
            heap[pos].heap_idx = pos
            pos = parentpos

            continue
        break
    heap[pos] = newitem  # move
    heap[pos].heap_idx = pos


t = int(input())
ans = []
for _ in range(t):
    n = int(input())
    srvs = []
    for idx, x in enumerate(input().split()):
        srvs.append(Obj(val=int(x), arr_idx=idx))

    cnt = defaultdict(int)
    for obj in srvs:
        cnt[obj.val] += 1
    unqcnt = len(cnt.keys())

    def update(el, additive):
        global unqcnt

        cnt[el] -= 1
        if cnt[el] == 0:
            unqcnt -= 1

        el = max(el - additive, 0)

        cnt[el] += 1

        if cnt[el] == 1:
            unqcnt += 1

        return el


    h = []
    for i in range(n):
        heappush(h, srvs[i])

    while unqcnt != 1:
        mx = heappop(h)
        mx.val = update(mx.val, 2)
        heappush(h, mx)

        prev = heappop_i(h, srvs[(mx.arr_idx - 1 + n) % n].heap_idx)
        prev.val = update(prev.val, 1)
        heappush(h, prev)

        if unqcnt == 1:
            break


    ans.append(str(heappop(h).val))



print('\n'.join(ans))
