﻿#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

void dfs(vector<vector<ll>>& gr, vector<bool>& used, ll v, vector<ll>& t) {
    used[v] = true;
    for (auto i : gr[v]) {
        if (!used[i]) dfs(gr, used, i, t);
    }
    t.push_back(v);
}

void doTopSort(vector<vector<ll>>& gr, vector<bool>& used, vector<ll>& ans) {
    ans.clear();
    for (int i = 0; i < gr.size(); i++) {
        if (!used[i]) dfs(gr, used, i, ans);
    }
    reverse(ans.begin(), ans.end());
}

int main()
{
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector <vector<ll>> gr(n);
        vector<pair<ll, ll>> p(m);
        vector <ll> vx(n);
        for (int i = 0; i < m; i++) {
            ll x, y;
            cin >> x >> y;
            x--; y--;
            p[i] = { x, y };
            gr[x].push_back(y);
            vx[y]++;
        }
        vector<bool> used(n);
        vector<ll> ans;
        doTopSort(gr, used, ans);
        map<ll, ll>dict;
        for (int i = 0; i < ans.size(); i++) {
            dict[ans[i]] = i;
        }
        ll cnt = 0;
        for (int i = 0; i < m; i++) {
            if (dict[p[i].first] < dict[p[i].second]) cnt++;
        }
        if (cnt >= m / 2) {
            for (auto i : ans) cout << ++i << " ";
            cout << endl;
        }
        else {
            vector<pair<ll, ll>> v;
            for (int i = 0; i < n; i++) {
                v.push_back({ gr[i].size() - vx[i], i });
            }
            sort(v.begin(), v.end());
            reverse(v.begin(), v.end());
            for (auto i : v) cout << i.second + 1 << " ";
            cout << endl;
        }
    }
    return 0;
}

