#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <set>
#include <map>
#include <stack>


using namespace std;

typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
        cout << "\n";
    }
}

struct Degree {
    int in, v;

    bool operator<(const Degree& other) const {
        if (in == other.in) return v < other.v;
        return in > other.in;
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), h(n);
    vector<int> out(n), in(n);
    int mxOut = 0;
    int mxIn = 0;

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        g[b].push_back(a);
        h[a].push_back(b);
        mxOut = max(mxOut, ++out[a]);
        mxIn = max(mxIn, ++in[b]);
    }


    vector<set<Degree>> vByOut(mxOut + 1);

    for (int i = 0; i < n; ++i) {
        vByOut[out[i]].insert({ in[i], i });
    }

    int k = 0;
    stack<int> ans;
    vector<int> used(n);

    for (int i = 0; i <= mxOut; ++i) {
        while (!vByOut[i].empty()) {
            auto firstRes = vByOut[i].begin();
            int first = firstRes->v;
            vByOut[i].erase(firstRes);
            used[first] = 1;

            for (auto x : h[first]) {
                if (used[x]) continue;
                vByOut[out[x]].erase({ in[x], x });
                --in[x];
                vByOut[out[x]].insert({ in[x], x });
            }

            for (auto x : g[first]) {
                if (used[x]) continue;
                vByOut[out[x]].erase({ in[x], x });
                --out[x];
                vByOut[out[x]].insert({ in[x], x });
                ++k;
            }

            ans.push(first);
            i = max(0, i - 1);
        }
    }

    while (!ans.empty()) {
        cout << ans.top() + 1 << " ";
        ans.pop();
    }
}