#include<iostream>
#include<fstream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<queue>
#include<stack>
#include<set>
#include<map>

using namespace std;
typedef long long ll;

ll n, m;
vector<vector<ll>> G;
vector<char> used;
vector<ll> topsort;
void dfs(ll u) {
    used[u] = 'g';
    for (ll v : G[u])
        if (used[v] == 'w')
            dfs(v);
    used[u] = 'b';
    topsort.push_back(u);
}

void process_test() {
    cin >> n >> m;
    G.assign(n, vector<ll>());
    used.assign(n, 'w');
    topsort.clear();

    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        G[u].push_back(v);
    }

    for (ll i = 0; i < n; i++)
        if (used[i] == 'w')
            dfs(i);
    vector<bool> processed(n, false);
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        processed[topsort[i]] = true;
        for (ll j = 0; j < G[topsort[i]].size(); j++)
            if (processed[G[topsort[i]][j]])
                cnt++;
    }
    if (cnt <= m / 2) {
        for (ll i = 0; i < n; i++)
            cout << topsort[i] + 1 << ' ';
        cout << '\n';
        return;
    }
    
    processed.assign(n, false);
    cnt = 0;
    for (ll i = n - 1; i >= 0; i--) {
        processed[topsort[i]] = true;
        for (ll j = 0; j < G[topsort[i]].size(); j++)
            if (processed[G[topsort[i]][j]])
                cnt++;
    }
    if (cnt <= m / 2) {
        for (ll i = n - 1; i >= 0; i--)
            cout << topsort[i] + 1 << ' ';
        cout << '\n';
        return;
    }
    cout << "-1\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++)
        process_test();
}