﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <deque>
#include <stack>
#include <list>
#include <bitset>
#include <string>

#define num long long

using namespace std;

void solution() {
	num n;
	cin >> n;

	vector<pair<num, num>> nums(n);
	for (num i = 0; i < n; i++) {
		cin >> nums[i].first;
	}

	for (num i = 0; i < n; i++) {
		cin >> nums[i].second;
	}

	
	sort(nums.begin(), nums.end(), 
		[&](pair<num, num>& x, pair<num, num>& y) {
			return (x.first < y.first) || ((x.first == y.first) && (x.second < y.second));
		}
	
	);

	num dif = 0;

	for (num i = 0; i < n; i++) {
		num nowDif = nums[i].second - nums[i].first;
		if (dif > nowDif) {
			cout << "-1" << '\n';
			return;
		}
		dif = nowDif;
	}

	cout << dif << '\n';
}

num search(num x, vector<num> nums) {
	num left = 0; num right = nums.size();
	num mid = (left + right) / 2;
	while (left + 1 < right) {
		if (nums[mid] <= x) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	return left;

}
 
int main() {
	ios_base::sync_with_stdio(false);
	num n;
	cin >> n;
	while (n--) {
		solution();
	}

	return 0;
}
